package com.ssm.manage.dao.impl;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ssm.core.impl.BaseDaoImpl;
import com.ssm.manage.dao.SsmSysCompanyDao;
import com.ssm.manage.dao.SsmSysCompanyStoreDao;
import com.ssm.manage.entity.SysCompany;
import com.ssm.manage.entity.SysCompanyStore;
import com.ssm.manage.mapper.SysCompanyStoreMapper;
import com.ssm.manage.query.SysCompanyRequest;
import com.ssm.manage.query.SysCompanyStoreRequest;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import tk.mybatis.mapper.entity.Example;

import java.util.List;

@Component
public class SsmSysCompanyStoreDaoImpl extends BaseDaoImpl<SysCompanyStore> implements SsmSysCompanyStoreDao {

    @Autowired
    private SysCompanyStoreMapper mapper;

    @Override
    public SysCompanyStoreMapper getMapper() {
        return mapper;
    }

    @Override
    public PageInfo<SysCompanyStore> selectPage(SysCompanyStoreRequest sysCompanyStoreRequest) {
        Example example = new Example(SysCompanyStore.class);
        Example.Criteria criteria = example.createCriteria();
        if (StringUtils.isNotBlank(sysCompanyStoreRequest.getCompanyCode())){
            criteria.andLike("companyCode","%" + sysCompanyStoreRequest.getCompanyCode()+ "%");
        }
        if (StringUtils.isNotBlank(sysCompanyStoreRequest.getCompanyName())){
            criteria.andLike("companyName","%" + sysCompanyStoreRequest.getCompanyName()+ "%");
        }
        if (StringUtils.isNotBlank(String.valueOf(sysCompanyStoreRequest.getStoreId()))){
            criteria.andEqualTo("storeId",sysCompanyStoreRequest.getStoreId());
        }
        if (StringUtils.isNotBlank(sysCompanyStoreRequest.getStoreNum())){
            criteria.andLike("storeNum","%" + sysCompanyStoreRequest.getStoreNum()+ "%");
        }
        if (StringUtils.isNotBlank(sysCompanyStoreRequest.getStoreName())){
            criteria.andLike("storeName","%" + sysCompanyStoreRequest.getStoreName()+ "%");
        }
        sysCompanyStoreRequest.setSort("companyStoreId");
        PageHelper.startPage(sysCompanyStoreRequest.getPageNum(),sysCompanyStoreRequest.getPageSize(),sysCompanyStoreRequest.getOrderAndSort());
        List<SysCompanyStore> list = mapper.selectByExample(example);
        PageInfo<SysCompanyStore> pageInfo = new PageInfo<>(list);
        return pageInfo;
    }
}
